#include "config.h"
#include "system.h"

#include "rand_sleep.h"

#include <stdlib.h>
#include <Winsock2.h>
#define uint unsigned int


int gettimeofday (struct timeval *tv, void* tz) 
{ 
  union { 
    __int64 ns100; /*time since 1 Jan 1601 in 100ns units */ 
    FILETIME ft; 
  } now; 


  GetSystemTimeAsFileTime (&now.ft); 
  tv->tv_usec = (long) ((now.ns100 / 10LL) % 1000000LL); 
  tv->tv_sec = (long) ((now.ns100 - 116444736000000000LL) / 10000000LL); 
  return (0); 
} 


/*
int gettimeofday(struct timeval* tp, void* tzp) {
    DWORD t;
    t = timeGetTime();
    tp->tv_sec = t / 1000;
    tp->tv_usec = t % 1000;
    return 0;
} */

void rand_sleep(double min, double max)
{
    static bool need_init = true;
    long delay;

    if (need_init) {
	struct timeval timeval;
	need_init = false;
	
	

	gettimeofday(&timeval, NULL);
	srand((uint)timeval.tv_usec); /* RATS: ignore - this is safe enough */
    }
    delay = (int)(min + ((max-min)*rand()/(RAND_MAX+1.0)));
    bf_sleep(delay);
}
